#include <avr/sleep.h>
#include <avr/interrupt.h>

int counter = 0;
int Time = 1;
long Time1 = 30;   //seconds
long Time2 = 430;  //seconds
int Delay;

byte Sensor = 3;
byte LED_Time1 = 0;
byte LED_Time2 = 4;
byte LED_UV_on = 2;
byte Mosfet = 1;

unsigned long last;

unsigned long Time_on = 30;   //Time in seconds, after it shuts itself down



void setup() {////////////////////////////////////////////////////////////////////////////////////////////////

  pinMode(Sensor, INPUT);
  pinMode(LED_Time1, OUTPUT);
  pinMode(LED_Time2, OUTPUT);
  pinMode(LED_UV_on, OUTPUT);
  pinMode(Mosfet, OUTPUT);
}


void loop() {////////////////////////////////////////////////////////////////////////////////////////////////

  if (digitalRead(Sensor) == 1) {
    do {
      counter++;
      delay(10);
    } while ((digitalRead(Sensor) == 1) && (counter < 201));

    last = millis(); //Time of last operation

  }

  if ((counter > 1) && (counter < 150)) {
    Time++;
    if (Time > 2) {
      Time = 1;
    }
  }




  if (Time == 1) {
    digitalWrite(LED_Time1, 1);
  } else {
    digitalWrite(LED_Time1, 0);
  }

  if (Time == 2) {
    digitalWrite(LED_Time2, 1);
  } else {
    digitalWrite(LED_Time2, 0);
  }


  if ((counter > 150) && (counter < 400)) {  //UV on
    digitalWrite(LED_UV_on, 1);
    analogWrite(Mosfet, 205);                // 255 / 4.1V + 3.3V = 205.24 
    counter = 0;

    if (Time == 1) {
      do {
        delay(100);

        if (digitalRead(Sensor) == 1) {      //Cancel timer
          do {
            counter++;
            delay(10);
          } while ((digitalRead(Sensor) == 1) && (counter < 401));
        }
      } while ((millis() - last < (Time1 * 1000)) && (counter < 401));
    }


    if (Time == 2) {
      do {
        delay(100);

        if (digitalRead(Sensor) == 1) {       //Cancel timer
          do {
            counter++;
            delay(10);
          } while ((digitalRead(Sensor) == 1) && (counter < 401));
        }
      } while ((millis() - last < (Time2 * 1000)) && (counter < 401));
    }
    digitalWrite(LED_UV_on, 0);
    digitalWrite(Mosfet, 0);
    delay(250);
    last = millis();                           //Time of last operation
  }

  counter = 0;

  delay(100);

  if (millis() - last > (Time_on * 1000)) {    //Go to bed ;)
    sleep();
  }

}

void sleep() {////////////////////////////////////////////////////////////////////////////////////////////////
  

  digitalWrite(LED_Time1, 0);
  digitalWrite(LED_Time2, 0);

    //When waking up the same time should be chosen as bevore
  if (Time == 1) {
     Time = 2;
    }

    if (Time == 2) {
      Time = 1;
    }

  GIMSK |= _BV(PCIE);                     // Enable Pin Change Interrupts
  PCMSK |= _BV(PCINT3);                   // Use PB3 as interrupt pin
  ADCSRA &= ~_BV(ADEN);                   // ADC off
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);    // replaces above statement

  sleep_enable();                         // Sets the Sleep Enable bit in the MCUCR Register (SE BIT)
  sei();                                  // Enable interrupts
  sleep_cpu();                            // sleep

  cli();                                  // Disable interrupts
  PCMSK &= ~_BV(PCINT3);                  // Turn off PB3 as interrupt pin
  sleep_disable();                        // Clear SE bit
  ADCSRA |= _BV(ADEN);                    // ADC on

  sei();                                  // Enable interrupts
} // sleep

ISR(PCINT0_vect) {
  // This is called when the interrupt occurs, but I don't need to do anything in it
}
